$(document).ready(function() {
	if (window.Eqsash) {
		window.location.origin = window.location.origin ? window.location.origin : window.location.protocol+'//'+window.location.hostname+(window.location.port ? ':' + window.location.port : '');

		window.amessageDomain = window.location.origin;
		window.amessageUrl = window.amessageDomain+Eqsash.interim+'/api';
		window.amessageKey = '12345';
		
		userInit();
	}
	
	var l = new URL(window.location.href).searchParams.get('l');
	window.amessageLanguage = l ? l : '';

	window.amessageSend = 'key='+window.amessageKey+'&l='+window.amessageLanguage;
	
	amessageMessageInit();
});

//

function userInit() {
	$('.amessage-user-search-result-item').click(function (e) {
		e.preventDefault();
		
		var recipient = $(this).attr('data-id');
		
		$.post(window.amessageUrl, window.amessageSend+'&module=message&method=get_data_user', function (data) {
			try {
				var data = $.parseJSON(data);
				
				var message = prompt(data['user_message']);

				if (message != null && message != '') {
					var data = window.amessageSend;
					data += '&module=message';
					data += '&method=send';
					data += '&type=text';
					data += '&content='+message;
					data += '&recipient='+recipient;
					data += '&domain='+window.amessageDomain;
					
					$.post(window.amessageUrl, data, function (data) {
						window.location = window.amessageDomain+Eqsash.interim+'/amessage';
					});
				}
			} catch (e) {
				d(data);
			}
		});
	});
}

//

function amessageMessageInit() {
	amessageSetFormContact();
	
	$.post(window.amessageUrl, window.amessageSend+'&module=message&method=get_data_common', function (data) {
		try {
			var data = $.parseJSON(data);
			window.amessageSettingsMessage = data['settings'];
			window.amessageDataMessage = data['data'];
			window.amessageUserId = window.amessageDataMessage['user_id'];
			
			$('head').append(window.amessageDataMessage['style']);
			
			if ($('.amessage-widget').is('div')) {
				amessageUpdateWidget();
			} else if ($('.amessage-dialogs').is('div')) {
				amessageSetDialogs();
				amessageUpdateDialogs();
			} else {
				if ($('.amessage-dialogs-empty').is('div')) {
					setTimeout(function () {
						if ($('.amessage-dialogs-empty').is('div')) {
							window.location.reload();
						}
					}, window.amessageSettingsMessage['time_refresh'] * 2 * 1000);
				}
			}
		} catch (e) {
			d(data);
		}
	});
}

function amessageUpdateWidget() {	
	$('head').append('<link rel="stylesheet" href="'+window.amessageDomain+window.amessageInterim+'/custom/modules/message/css/message.css">');
	
	if (window.amessageSettingsMessage['recipient_status']) {
		$('.amessage-widget-header-status').css('color', '#0c0');
		$('.amessage-widget-header-status').attr('title', window.amessageSettingsMessage['phrase_online']);
	}
	
	if (window.amessageSettingsMessage['message_greeting']) {
		setTimeout(function () {
			if ($('.amessage-dialog-empty').is(':visible')) {		
				$.post(window.amessageUrl, window.amessageSend+'&module=message&method=send&message_greeting=1', function (data) {
					try {
						var data = $.parseJSON(data);
					} catch (e) {
						d(data);
					}
				});
			}
		}, window.amessageSettingsMessage['time_refresh'] * 2 * 1000);
	}

	amessageGetMessages();
}

function amessageSendMessageText() {
	var file = $('.amessage-dialog-control-file input');
	
	$('.amessage-dialog-file').click(function (e) {
		file.click();
	});
	
	file.change(function (e) {
		var length = file[0].files.length;
		if (length) {
			$('.amessage-dialog-control .count span').html(length);
		} else {
			$('.amessage-dialog-control .count span').html('');
		}
	});
	
	
	$('.amessage-dialog-send').click(function (e) {
		var textarea = $('.amessage-dialog-textarea');
		var content = textarea.val();
		var files = file[0].files;
	
		if (content != '' || files.length) {
			var recipient = 1;
			if ($('.amessage-dialog-messages').is('div')) {
				recipient = $('.amessage-dialog-messages').attr('data-id');
			}
			
			var formData = new FormData();
			
			for (var i = 0; i < files.length; i++) {
				formData.append('file['+i+']', files[i]);
			}
			
			formData.append('key', window.amessageKey);
			formData.append('l', window.amessageLanguage);
			formData.append('module', 'message');
			formData.append('method', 'send');
			formData.append('type', 'text');
			formData.append('content', content);
			formData.append('recipient', recipient);
			formData.append('domain', window.amessageDomain);

			$.ajax({
				url : window.amessageUrl,
				type : 'POST',
				data : formData,
				processData: false,
				contentType: false,
				success : function(data) {
					textarea.val('');
					file.val('');
					file.change();
					
					var data = $.parseJSON(data);
					
					$('.amessage-dialog-content').html(data['content']);
					$('.amessage-dialog-content').scrollTop(9999);
					
					amessageSetMessageAudio();
					amessageSetEmailRequest();
					
					$('.amessage-dialog-textarea').focus();
				},
				error : function(data) {
					d(data);
				}
			});
		}
	});
}

function amessageSendMessageAudio(button) {
	var isMicrophone = false;
	
	$('.amessage-dialog-record').click(function (e) {
		if (!isMicrophone) {
			navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia;
			navigator.getUserMedia({audio: true}, handleSuccess, handleError);
			
			isMicrophone = true;
		}
	});

	function handleSuccess(stream) {
		var recipient = 1;
		if ($('.amessage-dialog-messages').is('div')) {
			recipient = $('.amessage-dialog-messages').attr('data-id');
		}
		
		var mediaRecorder = new MediaRecorder(stream);
		var chunks = [];
		
		var audioLength = '0:1';
		var timer = 0;
		
		var interval = setInterval(function() {
			if (timer == 0) return;
			
			var date = new Date(new Date().getTime() - timer);
			var minutes = date.getMinutes();
			var seconds = date.getSeconds();
			
			if (minutes == 0 && seconds == 0) {
				seconds = '1';
			}
			
			audioLength = minutes+':'+seconds;
		}, 1000);
		
		mediaRecorder.start();
		
		timer = new Date().getTime();
		interval;
		
		var iconMicrophoneUrl = window.amessageDataMessage['ICON_MICROPHONE_URL'];
		var iconMicrophoneRecUrl = window.amessageDataMessage['ICON_MICROPHONE_REC_URL'];
		
		$('.amessage-dialog-record').css('background', 'url('+iconMicrophoneRecUrl+')');
		
		$(button).click(function (e) {
			if (mediaRecorder.state == 'inactive') {
				mediaRecorder.start();
				
				timer = new Date().getTime();
				interval;
				
				$(this).css('background', 'url('+iconMicrophoneRecUrl+')');
			} else {
				mediaRecorder.stop();
				
				timer = 0;
				
				$(this).css('background', 'url('+iconMicrophoneUrl+')');
				
				chunks = [];
			}
		});

		mediaRecorder.ondataavailable = function(event) {
			chunks.push(event.data);
			
			var audioBlob = new Blob(chunks, {'type' : 'audio/mpeg'});
			
			var formData = new FormData();
			formData.append('key', window.amessageKey);
			formData.append('l', window.amessageLanguage);
			formData.append('module', 'message');
			formData.append('method', 'send');
			formData.append('type', 'audio');
			formData.append('content', audioBlob);
			formData.append('length', audioLength);
			formData.append('recipient', recipient);
			formData.append('domain', window.amessageDomain);
			
			var xhr = new XMLHttpRequest();
			xhr.open('POST', window.amessageUrl);
			xhr.send(formData);
			xhr.onreadystatechange = function() {
				if (xhr.status == 200 && xhr.readyState == 4) {
					var data = xhr.responseText;
					try {
						data = $.parseJSON(data);
						
						$('.amessage-dialog-content').html(data['content']);
						$('.amessage-dialog-content').scrollTop(9999);
						
						amessageSetMessageAudio();
						amessageSetEmailRequest();
						
						$('.amessage-dialog-textarea').focus();
					} catch (e) {
						d(e);
					}
				}
			};
		}
	}

	function handleError(error) {
		alert(window.amessageDataMessage['MICROPHONE_ERROR']);
	}
}

function amessageSetMessageAudio() {
	if ($('.amessage-dialog-message').is('div')) {		
		$('.amessage-dialog-message-audio button').click(function () {
			var parent = $(this).parent();
			var button = $(this);
			var audio = $('audio', parent)[0];
			var duration = $('.amessage-dialog-message-audio-duration', parent);
			
			var iconPlayUrl = window.amessageDataMessage['ICON_PLAY_URL'];
			var iconPauseUrl = window.amessageDataMessage['ICON_PAUSE_URL'];
			
			if (audio.paused == false) {
				audio.pause();
				button.css('background', 'url('+iconPlayUrl+')');
			} else {
				audio.play();
				button.css('background', 'url('+iconPauseUrl+')');
			}
			
			audio.onended = function () {
				button.css('background', 'url('+iconPlayUrl+')');
			};
			
			audio.ontimeupdate = function () {
				var date = new Date(audio.currentTime * 1000);
				duration.html(date.getMinutes()+':'+date.getSeconds());
			};
		});
	}
}

function amessageGetMessages(recipient) {
	var userId = window.amessageUserId;
	
	if (recipient == undefined) {
		recipient = window.amessageSettingsMessage['recipient_id'] == undefined ? 1 : window.amessageSettingsMessage['recipient_id'];
	}
	
	var isFirst = true;
	var timerId;
	
	var getDialog = function() {
		if (isFirst || ($('.amessage-dialog-messages[data-id="'+recipient+'"]').is('div') && $('.amessage-dialog-control').is(':visible'))) {
			var isRead = $('.amessage-widget').is('div') && !$('.amessage-widget').is(':visible') ? 0 : 1;
			
			$.post(window.amessageUrl, window.amessageSend+'&module=message&method=render_dialog&recipient='+recipient+'&domain='+window.amessageDomain+'&is_read='+isRead, function (data) {
				try {
					var data = $.parseJSON(data);
					
					if ((data['is_unread'] && $('.amessage-dialog-message').hasClass('amessage-dialog-message-unread')) || isFirst || data['count_messages'] != $('.amessage-dialog-message', '.amessage-dialog-messages[data-id="'+recipient+'"]').length) {				
						$('.amessage-dialog-content').hide();
						
						$('.amessage-dialog-content').html(data['content']);
						
						if (isFirst) {
							$('.amessage-dialog-control').html(data['control']);
							amessageSendMessageAudio('.amessage-dialog-record', '.amessage-dialog-content');
							amessageSendMessageText();
						}
						
						$('.amessage-dialog-content').fadeIn(500);
						
						amessageSetMessageAudio();
						amessageSetEmailRequest();
						
						setTimeout(function () {
							$('.amessage-button-new').show();
						}, 1000);
						
						$('.amessage-dialogs-dialog[data-id="'+recipient+'"] .amessage-dialogs-dialog-user-new').hide();
						
						isFirst = false;
						
						var scrollTopDialog = function() { 
							$('.amessage-dialog-content').scrollTop(9999);
						};
						
						setTimeout(scrollTopDialog, 500);
					}
					
					timerId = setTimeout(getDialog, window.amessageSettingsMessage['time_refresh'] * 1000);
				} catch (e) {
					d(data);
				}
			});
		} else if ($('.amessage-dialog-messages[data-id="'+recipient+'"]').is('div') && !$('.amessage-dialog-control').is(':visible')) {
			timerId = setTimeout(getDialog, window.amessageSettingsMessage['time_refresh'] * 1000);
		} else {
			clearTimeout(timerId);
		}
	};
	
	getDialog();
	
	if (userId == recipient && $('.amessage-widget').is(':visible')) {
		$('.amessage-button, .amessage-button-tooltip').click(function () {	
			$('.amessage-widget .amessage-dialog-content, .amessage-widget .amessage-dialog-control').hide();
			$('.amessage-widget .amessage-dialogs').show();
		});
	
		amessageUpdateDialogs();
	}
}

function amessageSetDialogs() {
	$('.amessage-dialogs-dialog-delete').click(function (e) {
		if (confirm(window.amessageDataMessage['DIALOG_DELETE'])) {
			$.post(window.amessageUrl, window.amessageSend+'&module=message&method=delete_dialog&recipient='+$(this).parent().attr('data-id'), function () {
				location.reload();
			});
		}
	});
	
	$('.amessage-dialogs-dialog-user').click(function (e) {
		if ($(this).parent().parent().hasClass('amessage-dialogs')) {	
			$('.amessage-widget .amessage-dialog-content, .amessage-widget .amessage-dialog-control').show();
			$('.amessage-widget .amessage-dialogs').hide();
		}
		
		var recipient = $(this).parent().attr('data-id');
		
		$('.amessage-dialogs-dialog-user-new', $(this)).hide();
		$('.amessage-dialogs-dialog').removeClass('amessage-dialogs-dialog-active');
		$(this).parent().addClass('amessage-dialogs-dialog-active');
		
		$.post(window.amessageUrl, window.amessageSend+'&module=message&method=render_dialog&recipient='+recipient, function (data) {
			try {
				var data = $.parseJSON(data);
				
				$('.amessage-dialog-content').html(data['content']);
				$('.amessage-dialog-control').html(data['control']);
				
				if (data['user_info']) {
					$('.amessage-user-info').html(data['user_info']);			
					$('.amessage-user-info').show();
				} else {			
					$('.amessage-user-info').hide();
				}
				
				$('.amessage-dialog').show();
				
				amessageGetMessages(recipient);
				
				setTimeout(function () {
					$('.amessage-dialog-textarea').focus();
				}, 1000);
				
				amessageBlockUser();
			} catch (e) {
				d(data);
			}
		});
	});
}

function amessageUpdateDialogs() {
	var timerId;
	
	var getDialogs = function() {
		if ($('.amessage-dialogs').is('div')) {
			$.post(window.amessageUrl, window.amessageSend+'&module=message&method=render_dialogs&mode=update', function (data) {
				try {
					var data = $.parseJSON(data);
					
					if (data['is_new'] || data['count_dialogs'] != $('.amessage-dialogs-dialog').length) {
						var active = $('.amessage-dialogs-dialog-active').attr('data-id');
						
						$('.amessage-dialogs').html(data['content']);
						
						$('.amessage-dialogs-dialog[data-id="'+active+'"]').addClass('amessage-dialogs-dialog-active');

						amessageSetDialogs();
					}
					
					timerId = setTimeout(getDialogs, window.amessageSettingsMessage['time_refresh'] * 1000);
				} catch (e) {
					d(data);
				}
			});
		} else {
			clearTimeout(timerId);
		}
	};
	
	getDialogs();	
}

function amessageBlockUser() {
	$('.amessage-user-info-block a').click(function () {
		$.post(window.amessageUrl, window.amessageSend+'&module=message&method=block_user&user_id='+$('.amessage-dialog-messages').attr('data-id'), function (data) {
			$('.amessage-user-info-block a').html(data);
		});
	});
}

function amessageSetFormContact() {
	$('.amessage-widget-form form').submit(function (e) {
		e.preventDefault();
		
		$.post(window.amessageUrl, window.amessageSend+'&module=message&method=send_message_contacts&'+$(this).serialize(), function (data) {
			$('.amessage-widget-form form').hide();
			$('.amessage-widget-form span').css('color', '#0a0');
			$('.amessage-widget-form span').html(data);
		});
	});
}

function amessageSetEmailRequest() {
	setTimeout(function () {
		$('.email-request form').submit(function (e) {
			e.preventDefault();
			
			$.post(window.amessageUrl, window.amessageSend+'&module=message&method=send_email_request&'+$(this).serialize(), function (data) {
				$('.email-request').fadeOut(1000);
			});
		});
		
		$('.email-request .close').on('click', (function (e) {
			$('.email-request').fadeOut(1000);
		}));
	}, 2000);
}

//

function d(data) {
	console.log(data);
}
