function amessageWidgetInit() {
	setTimeout(function () {
		window.$ ? amessagePrepareWidget() : amessageAddScript('others/libraries/jquery/jquery.js', 'amessagePrepareWidget');
	}, 1000);
}

function amessagePrepareWidget() {
	if (!$.cookie) {
		amessageAddScript('custom/libraries/jquery/cookie.js', 'amessagePrepareWidget');
	} else {
		var l = new URL(window.location.href).searchParams.get('l');
		window.amessageLanguage = l ? l : '';
	
		window.amessageSend = 'key='+window.amessageKey+'&l='+window.amessageLanguage;
		
		var sessionName = $.cookie('session_name');
		if (sessionName) {
			var sessionId = $.cookie(sessionName);
			sessionId = sessionId ? sessionId : '';
			
			window.amessageSend += '&'+sessionName+'='+sessionId;
		}
		
		$.post(window.amessageUrl, window.amessageSend+'&module=message&method=get_widget&url='+window.location.origin, function (data) {
			try {
				var data = $.parseJSON(data);
				
				$.cookie('session_name', data['session_name'], {path: '/', expires: 365});
				$.cookie(data['session_name'], data['session_id'], {path: '/', expires: 365});
				window.amessageSend += '&'+data['session_name']+'='+data['session_id'];
				
				$('body').append(data['content']);
				
				amessageRunWidget();
			} catch (e) {
				d(data);
			}
		});
	}
}

function amessageRunWidget() {
	var widgetOpen = false;
	
	$('.amessage-button, .amessage-button-tooltip').click(function () {
		widgetOpen = true;
		
		$('.amessage-button-new').hide();
		$('.amessage-button-tooltip').hide();
		$('.amessage-button').hide(200);
		$('.amessage-widget').slideDown(300);
		$('.amessage-dialog-content').scrollTop(9999);
		
		$('.amessage-dialog-textarea').focus();
	});
	
	$('.amessage-widget-header-close').click(function () {
		$('.amessage-widget').slideUp(300);
		$('.amessage-button').show(400);
		$('.amessage-button-new').hide();
	});
	
	setTimeout(function () {
		if (widgetOpen == false) {
			$('.amessage-button-tooltip').fadeIn(250);
		}
	}, 5000);
	
	amessageAddScript('custom/modules/message/js/message.js');
}
