<?php

namespace custom\modules\message;
use core\{utility\Utility, user\User, route\Route, translation\Translation as T};

class Message {
	use Api, Data, Form;
	
	public $is_admin;
	public $user_id;
	
	function __construct() {
		$this->check_authentication();
	}
	
	function admin() {
		$admin = '<a href="'.Route::render_route('amessage').'">Основная страница</a><br><a href="'.Route::render_route('admin/message/settings').'">Настройки</a>';
		
		return $admin;
	}
	
	function get_home() {
		$home = '<a href="'.Route::render_route('user', false, false, true).'">'.T::get('Войдите').'</a> '.T::get('или').' <a href="'.Route::render_route('user/register', false, false, true).'"> '.T::get('зарегистрируйтесь').'</a>';
		if ((new User)->check_logged()) {
			Utility::add_library('custom/modules/message/js/message.js');
			Utility::add_library('custom/modules/message/css/message.css');
			$home = $this->render_dialogs();
		}
		
		return $home;
	}

	function get_settings() {	
		$settings = Utility::get_data('amessage_settings');
		
		if (isset($_POST['submit'])) {
			Route::clear_post();
			unset($_POST['submit']);
			
			if (is_numeric($_POST['recipient_id']) && is_numeric($_POST['time_refresh'])) {
				$settings['recipient_status'] = isset($_POST['recipient_status']) ? 1 : 0; 
				$settings['recipient_autorefresh'] = isset($_POST['recipient_autorefresh']) ? 1 : 0;
				
				unset($_POST['recipient_status'], $_POST['recipient_autorefresh']);
				
				Utility::set_data('amessage_settings', $_POST + $settings);
				Utility::set_message('Настройки сохранены');
			} else {
				Utility::set_message('Проверьте правильность заполнения полей', 'red');
			}
		} else if (isset($_POST['cancel'])) {
			Route::go('admin/message');
		}		
		
		$data = [
			'phrase_online' => $_POST['phrase_online'] ?? $settings['phrase_online'],
			'phrase_offline' => $_POST['phrase_offline'] ?? $settings['phrase_offline'],
			'message_greeting' => $_POST['message_greeting'] ?? $settings['message_greeting'],
			'route_home' => $_POST['route_home'] ?? $settings['route_home'],
			'privacy_policy' => $_POST['privacy_policy'] ?? $settings['privacy_policy'],
			'time_refresh' => $_POST['time_refresh'] ?? $settings['time_refresh'],
			'recipient_id' => $_POST['recipient_id'] ?? $settings['recipient_id'],
		];
		
		$result = $this->get_form_settings($data, $settings);
	
		return $result;
	}
}
